#include "Serial0.h"
#include cfCIAO_SERIAL0_IMPL_HEADER

#ifdef cfCIAO_INLINE
	#define _INLINE inline
#else
	#define _INLINE
#endif

namespace ciao { namespace dev { namespace std {


CIAO_CLASS_DEF( Serial0, cfCIAO_SERIAL0_IMPL );


// methods defined by both, os::dev::std::Serial0 and hw::hal::Serial0
	
_INLINE	bool Serial0::send( char ch ) {
	printf("ciao::dev::std::Serial0::send('%c') -->\n", ch );
	return impl()->send( ch );
}
	
// additional methods, only defined by os::dev::std::Serial0 
#ifndef cfCIAO_SERIAL0_IMPL_HW

_INLINE bool Serial0::send( const char* buf ) {
	printf("ciao::dev::std::Serial0::send(\"%s\") -->\n", buf );
	return impl()->send( buf );
}

#endif // cfCIAO_SERIAL0_IMPL_HW

}}}	// namespace ciao::dev::std

#undef _INLINE


