#include "Serial0.h"

#ifdef cfOS_INLINE
	#define _INLINE inline
#else
	#define _INLINE
#endif

namespace os { namespace dev { namespace std {
_INLINE bool Serial0::send( char ch ) {
	printf("os::dev::std::Serial0::send('%c') -->\n", ch);
	return Super::send( ch );
}

_INLINE bool Serial0::send( const char* buf ) {
	printf("os::dev::std::Serial0::send(\"%s\") -->\n", buf);
	for( const char* p = buf; *p; ++p ) {
		if( !Super::send( *p ) )
			return false;
	}
	return true;
}



}}}	// namespace os::dev::std

#undef _INLINE
