$SCHEME={
	task => {
		template=>"menu",
		name=>"[self]",
		type=>"bool",
		prompt=>"Task [self]",
		depends=>"kernel_tasks",
		default=>"y",
		options=>[
			{ template=>"choice",
			  prompt=>"belongs to component",
			  name=>"usesComponent",
			  options=>[
			  	{template=>"references",
			  	 list=>"component"
			  	}
			  ]
			},
			{ template=>"menu",
			  prompt=>"waits for events",
			  name=>"usesEvent",
			  options=>[
			  	{template=>"references",
			  	 list=>"event"
			  	}
			  ]
			},
			{ template=>"choice",
			  prompt=>"schedule",
			  name=>"schedule",
			  options=>[
			  	{template=>"config",
				 name=>"non",
				 prompt=>"non",
				 depends=>"kernel_nonpreemptive || kernel_mixedpreemptive",
				 type=>"bool",
				},
				{template=>"config",
				 name=>"full",
				 prompt=>"full",
				 depends=>"kernel_fullpreemptive || kernel_mixedpreemptive",
				 type=>"bool",
				}
			  ]
				
			},
			{template=>"menuconfig",
			 name=>"hasActivation",
			 prompt=>"multiple activation",
			 type=>"bool",
			 default=>"n",
			 depends=>"kernel_multipleactivation",
			 options=>[
			 ]
			},
			
			{template=>"config",
			 name=>"activation",
			 prompt=>"activation",
			 type=>"int",
			 default=>"1"
			},
			{template=>"config",
			 name=>"priority",
			 prompt=>"priority",
			 type=>"int",
			 range=>"0 cfOS_MAX_PRIORITY",
			 default=>"0"
			},
			{template=>"config",
			 name=>"stacksize",
			 prompt=>"stacksize",
			 type=>"int",
			 default=>"128"
			},
		]
	
	},
	isr => {
		template=>"menu",
		name=>"[self]",
		type=>"bool",
		prompt=>"ISR [self]",
		default=>"y",
		options=>[
			{ template=>"choice",
			  prompt=>"used by Component",
			  name=>"isrUsedByComponent",
			  options=>[
			  	{template=>"config",
			  	 name=>"none",
			  	 prompt=>"none",
			  	 type=>"bool"
			  	},
			  	{template=>"references",
			  	 list=>"component"
			  	
			  	}
			  
			  ]
				
			},
			{template=>"config",
			 name=>"function",
			 prompt=>"function",
			 type=>"string",
			 default=>"functionISR[self]"
			},
			{template=>"config",
			 name=>"device",
			 prompt=>"device",
			 type=>"string",
			 default=>"DMA_SYSSRC2"
			},
			{template=>"config",
			 name=>"category",
			 prompt=>"category",
			 type=>"int",
			 default=>"2",
			 range=>"1 2"
			},
		]
	
	},
	component=>{ template=> "menu",
		     name=>"[self]",
		     prompt=>"Component [self]",
		     type=>"bool",
		     default=>"y",
		     options=>[
				 { template=>"choice",
				  prompt=>"application",
				  name=>"componentRefApp",
				  options=>[
				  	{template=>"references",
				  	 list=>"osapplication"
				  	
				  	}
				  
				  ]
				
				},
				{template=>"menu",
			     prompt => "Shared Memory",
			     name => "componentRefShm",
			     options=>[
			     	{template=>"references",
			     	 list=>"sharedmemory",
			     	 options=>[
			     	 	{ template=>"choice",
				  			prompt=>"Mode",
				  			name=>"mode",
				  			options=>[
				  				{template=>"config",
							 	name=>"rw",
								 prompt=>"rw",
			 					type=>"bool"
			 					},
					
				  				{template=>"config",
							 	name=>"r",
								 prompt=>"r",
			 					type=>"bool"
								},
				  
				  			]
				
						},
			     	 
			     	 
			     	 ]
			     	}
			     	
			     ]
			     }
			
		     #	{
		     #	  template=>"choice",
		     #	  name=>"senderport",
		     #	  prompt=>"senderport",
		     #	  options=>[
		     #	  	{template=>"config",
		     #	  	 name=>"none",
		     #	  	 prompt=>"none",
		     #	  	 type=>"bool"
		     #	  	},
		     #	  	{template=>"references",
		     #	  	 list=>"msgPort"
		     #	  	}
		     #	  
		     #	  
		     #	  ]
		     #
		     #},
		     #{
		     #	  template=>"choice",
		     #	  name=>"receiverport",
		     #	  prompt=>"receiverport",
		     #	  options=>[
		     #	  	{template=>"config",
		     #	  	 name=>"none",
		     #	  	 prompt=>"none",
		     #	  	 type=>"bool"
		     #	  	},
		     #	  	{template=>"references",
		     #	  	 list=>"msgPort"
		     #	  	}
		     #	  
		     #	  
		     #	  ]
		     #
		     #}
		     #
		     #
		     ]
	
	},
	event =>{
		template=>"config",
		name=>"[self]",
		type=>"bool",
		prompt=>"Event [self]",
		default=>"y"
	
	},
	appmode=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"Application Mode [self]",
		type=>"bool",
		default=>"y",
		options=>[
			{template=>"menu",
			 name=>"autostart",
			 prompt=>"autostart tasks",
			 options=>[
			 	{template=>"references",
			 	 list=>"task"
			 	}
			 ]
			 
			}
		
		]
	},
	'counter'=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"Counter [self]",
		type=>"bool",
		options=>[
			{
				template=>"config",
				name=>"maxallowedvalue",
				prompt=> "max allowed value",
				type=>"int",
				default=>"2147483647",
			},
			{
				template=>"config",
				name=>"ticksperbase",
				prompt=> "ticks / base",
				type=>"int",
				default=>"1",
			},
			{
				template=>"config",
				name=>"mincycle",
				prompt=> "min cycle",
				type=>"int",
				default=>"75000",
			},
		]
	},
	'alarm'=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"Alarm [self]",
		type=>"bool",
		options=>[
		{ 
			template=>"choice",
			prompt=>"based on counter",
			name=>"basedOnCounter",
			options=>[
			{
				template=>"references",
				list=>"counter"
			}
			]
		},
		{
				template=>"config",
				name=>"armed",
				prompt=> "armed",
				type=>"bool",
				default=>"n",
			},
			{
				template=>"config",
				name=>"absolutelifetime",
				prompt=> "absolute lifetime",
				type=>"int",
				default=>"0",
			},
			{
				template=>"config",
				name=>"cycletime",
				prompt=> "cycle time",
				type=>"int",
				default=>"0",
			},
			{
				template=>"menuconfig",
				name=>"activatetask",
				prompt=> "activate task",
				type=>"bool",
				default=>"y",
				options=>[
					{
				     	  template=>"choice",
				     	  name=>"task",
				     	  prompt=>"task",
				     	  options=>[
				     	  	{template=>"references",
				     	  	 list=>"task"
				     	  	}
				     	  ]
				}]
			},
		]
	},
	osapplication=>{
		template=>"choice",
		name=>"[self]",
		prompt=>"Application [self]",
		options=>[
			{template=>"config",
			 name=>"trusted",
			 prompt=>"trusted",
			 type=>"bool",
			},
			{template=>"config",
			 name=>"untrusted",
			 prompt=>"untrusted",
			 type=>"bool",
			},
			#{template=>"menu",
			# name=>"uses",
			# prompt=>"component",
			# options=>[
			# 	{template=>"references",
			# 	 list=>"component"
			# 	}
			# ]
			#}
		]	
	},
	#netport=>{
	#}
	startupHook=>{
		template=>"config",
		name=>"[self]",
		prompt=>"Startup Hook [self]",
		type=>"bool",
	},
	msgPort=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"Message Port [self]",
		type=>"bool",
		default=>"y",
		options=>[
			{
			 template=>"config",
			 name=>"msgctype",
			 prompt=>"msgctype",
			 type=>"string",
			},
			{
			 template=>"config",
			 name=>"msgcount",
			 prompt=>"msgcount",
			 type=>"int",
			 default=>"1"
			},
			{
			 template=>"config",
			 name=>"msgcheaderfile",
			 prompt=>"msgcheaderfile",
			 type=>"string",
			},
			{
		     	  template=>"choice",
		     	  name=>"senderportref",
		     	  prompt=>"senderport",
		     	  options=>[
		     	  	{template=>"references",
		     	  	 list=>"component"
		     	  	}	  
		     	  ]
		     },
		     {
		     	  template=>"choice",
		     	  name=>"receiverportref",
		     	  prompt=>"receiverport",
		     	  options=>[
		     	  	{template=>"references",
		     	  	 list=>"component"
		     	  	}	  
		     	  ]
		     },
			
		
		]
	},
	netPort=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"network port [self]",
		type=>"bool",
		default=>"y",
		options=>[
			{template=>"config",
			 name=>"port",
			 prompt=>"port",
			 type=>"int",
			},
			{template=>"choice",
			 name=>"reciverPort",
			 prompt=>"receiver port",
			 options=>[
			 	{template=>"references",
			 	 list=>"msgPort"
			 	}
			 
			 ]
			},
			{template=>"choice",
			 name=>"senderPort",
			 prompt=>"sender port",
			 options=>[
			 	{template=>"references",
			 	 list=>"msgPort"
			 	}
			 
			 ]
			},
			{template=>"choice",
			 name=>"taskref",
			 prompt=>"Task",
			 options=>[
			 	{template=>"references",
			 	 list=>"task"
			 	}
			 
			 ]
			}
		]
	
	},
	sharedmemory=>{
		template=>"menu",
		name=>"[self]",
		prompt=>"shared memory [self]",
		type=>"bool",
		default=>"y",
		options=>[
			{template=>"config",
			 name=>"cheaderfile_cpp",
			 prompt=>"cpp header file",
			 type=>"string"
			},
			{template=>"config",
			 name=>"cheaderfile",
			 prompt=>"c header file",
			 type=>"string"
			},
			{template=>"config",
			 name=>"ctype",
			 prompt=>"c type",
			 type=>"string"
			}
		]
	
	}
}
