#include "stddef.h"

// must be provided by CiAO, if write(1,...) is used!
extern int __ciao_stdio_putc( char );

int write(int fildes, const void *buf, size_t nbyte) {
	size_t i;

	// we only support stdout, others reserved for possible
	// future use
	if(fildes != 1) return -1;

	for(i=0;i<nbyte;i++)
		if(0==__ciao_stdio_putc(((const char*)buf)[i]))
			break;

	return (int) i;
}

