[SECTION .text]

; void Continuation_go(x86Context*)
[GLOBAL Continuation_go]
Continuation_go:
	        mov eax, [esp+4]
	        mov ebx, [eax+0]
	        mov esi, [eax+4]
	        mov edi, [eax+8]
	        mov ebp, [eax+12]
	        mov esp, [eax+16]

	        ret

; void toc_switch (x86Context* save_to, x86Context* load_from)
[GLOBAL Continuation_switch]
Continuation_switch:
	        mov eax, [esp+4]
	        mov [eax+0],  ebx
	        mov [eax+4],  esi
	        mov [eax+8],  edi
	        mov [eax+12], ebp
	        mov [eax+16], esp

	        mov eax, [esp+8]
	        mov ebx, [eax+0]
	        mov esi, [eax+4]
	        mov edi, [eax+8]
	        mov ebp, [eax+12]
	        mov esp, [eax+16]

	        ret

