;;
;; PagingAsm.asm
;;
;;  Created on: Feb 17, 2010
;;      Author: bossel00
;;

section .text

;; extern "C" void paging_set_pagetable(void* pagetable)
global paging_set_pagetable
paging_set_pagetable:
        ; Basiszeiger setzen
        mov     eax, [esp+4]
        mov     cr3, eax
        ret

;; extern "C" void enable_paging(void* pagetable);
global enable_paging
enable_paging:
        enter   0, 0

        ; Basiszeiger setzen
        mov     eax, [ebp+8]
        mov     cr3, eax

        ; Paging aktivieren
        mov     eax, cr0
        or      eax, (1 << 31) | (1 << 16)  ; PG | WP
        mov     cr0, eax

        leave
        ret

;; extern "C" void disable_paging();
global disable_paging
disable_paging:
        ; Paging deaktivieren
        mov     eax, cr0
        and     eax, ~(1 << 31)
        mov     cr0, eax

        ret

