#ifndef OS_COM_ASCOM_RX_FILTER_MASKED_NEW_DIFFERS_MASKED_OLD_H
#define OS_COM_ASCOM_RX_FILTER_MASKED_NEW_DIFFERS_MASKED_OLD_H

#include "os/com/ComStack_Types.h"
#include "os/com/ascom/FilterAlgo.h"
#include "os/com/ascom/rx/RxSignalType.h"

namespace os { namespace com { namespace ascom {

namespace rxfilter {

/*
  static Bool
  MaskedNewEqualsX_Opaque(RxSignalRype const * RxSig) {
    return !Filter_MaskedNewEqualsX_Opaque(RxSig);
  }
*/
  template<typename T>
  Bool
  MaskedNewEqualsX(RxSignalType * RxSig, void const * NewValue) {
    return filter::MaskedNewEqualsX< T >(*(T const *)NewValue,
                                          (T)RxSig->FilterXValue(),
                                          (T)RxSig->FilterMask());
  }

}

}}}

#endif
