#ifndef __os_dev_ISRSample_h__
#define __os_dev_ISRSample_h__

#include "os/dev/std/SampleDriver.h"
#include "stdio.h"

namespace os { namespace dev {

	
class ISRSample {

	static bool Prologue() {
		printf("\r\nSampleDriver: prologue\n\r");
		os::dev::SampleDriver::Inst().nonsynced();
		return true;
	}

	static void Epilogue() {
		printf("\r\nSampleDriver: epilogue\n\r");
		os::dev::SampleDriver::Inst().synced();
	}
};


}} // os::dev::
	

#endif // __os_dev_ISRSample_h__


