// $Id$

#ifndef __OS_KRN_COUNTER_H__
#define __OS_KRN_COUNTER_H__

#include "util/types.h"
#include "ciaoConfig.h"

namespace os { namespace krn {

struct Counter {
	// data type to represent number of alarms
	typedef uint_t_value <(cfOS_NUMBER_OF_COUNTERS)>::T Id;
	typedef UInt32 Ticks;

	Ticks maxallowedvalue;
	Ticks ticksperbase;
	Ticks mincycle;

	Ticks value;

	void advanceCounter();
	static Counter& Inst (Id counterid);
	static void init();
};

extern Counter theCounters[];

inline Counter& Counter::Inst (Counter::Id counterid) {
    return theCounters [counterid];
}

}} // namespace os::krn

#endif // __OS_KRN_ALARM_H__
