#include "Mutex.h"

namespace os { namespace krn {

	void Mutex::p () { //sync!
		if (llocked()) {
			Id running = SchedImpl::Inst().getRunning();
			enqueue(running);
		
			unlock();
			SchedImpl::Inst().block(running);
			lock();
		}
		else
			llock();
	}

	void Mutex::v () { //sync?         
		if (isEmpty()) 
			lunlock();
		else {
			Id whom = dequeue(); //sync!
			
			SchedImpl::Inst().awake(whom);
			SchedImpl::Inst().setNeedReschedule();
		}
	}

}}	//os::krn
