#ifndef __BaseAllocator_h__
#define __BaseAllocator_h__

#include "util/types.h"
#include "util/defines.h"


//! Base class for all Allocator types
/**
 *  Used to propagate error messages
 *  TODO
 */
template<class T>
class BaseAllocator{
public:
	//! default constructor
	BaseAllocator(){}
	
	//! copy constructor
	BaseAllocator(const BaseAllocator& alloc){
		STATIC_ERROR(this_allocator_does_not_implement_a_copy_constructor);
	}
	
	//! TODO
	T* allocate(){
		return 0;
	}
	
	T* allocate(int n){
		return 0;
	}
	
	//! TODO
	void free (T* elem){}
};

#endif //__BaseAllocator_h__

