#ifndef USERCODE1_H_
#define USERCODE1_H_

#include "stdint.h"
#include "mailbox.h"

//TODO: SHOULD BE LOCATED IN SOME OS HEADER
#define CIAO_COMPONENT(name) \
class name {\
public:\
	static name &Inst() {\
		return inst_;\
	}\
private:\
	static name inst_;

#define CIAO_COMPONENT_INST(name) name name::inst_;
	
#define TASKDECL(TaskID)\
public:\
	static void functionTask##TaskID (void)

#define TASKDEF(component,TaskID)\
	void component::functionTask##TaskID (void)


CIAO_COMPONENT(A)
private:
	TASKDECL(T1);
public:
	static os::msg::message msgPool[10];
	static uint8_t buffer[10*10];
	static os::msg::senderData sender;
	static os::msg::SenderPort senderPort;
};

CIAO_COMPONENT(B)
private:
	TASKDECL(T2);
public:
	static os::msg::receiverData receiver;
	static os::msg::ReceiverPort receiverPort;
};

#endif /*USERCODE1_H_*/
