#ifndef USERCODE1_H_
#define USERCODE1_H_

//TODO: SHOULD BE LOCATED IN SOME OS HEADER
#define CIAO_COMPONENT(name) \
class name {\
public:\
	static name &Inst() {\
		return inst_;\
	}\
private:\
	static name inst_;

#define CIAO_COMPONENT_INST(name) name name::inst_;
	
#define TASKDECL(TaskID)\
public:\
	static void functionTask##TaskID (void)

#define TASKDEF(component,TaskID)\
	void component::functionTask##TaskID (void)


CIAO_COMPONENT(A)
private:
	TASKDECL(Memprot1_tc_d_App0_t_T0);
	TASKDECL(Memprot1_tc_d_App0_t_T2);	
};



CIAO_COMPONENT(B)
private:
	TASKDECL(Memprot1_tc_d_App1_t_T1);	
};

CIAO_COMPONENT(D)
private:
	TASKDECL(Memprot1_tc_d_App2_t_T3);	
};


#endif /*USERCODE1_H_*/
