#include "util/container/ChainBase.h"
//#include <stdio.h>

class IntChain :public ChainBase{
public:
	typedef ChainBase Base;
	
private:
	int _value;

public:
	IntChain(int value):Base(),_value(value){}
	IntChain(Base* next,int value):Base(next),_value(value){} 
	
	int value()	const{
		return _value;
	}
	
	IntChain* getNext(){
		return static_cast< IntChain* >( Base::getNext() );
	}
};


int main (){
	
////	Construct a Chain

	IntChain i2(123456);
	IntChain i1(&i2,23);
	IntChain i0(&i1,42);
	
	// Create iterator
    IntChain* iter = &i0;


    int ret = 0;
    while(iter != 0){
		//printf("value: %d\n",iter->_value);
        ret += iter->value(); 
        iter = iter->getNext();
    }
	
	return ret;
}

#ifndef makeARCH_i386
extern "C" void start(){
	main();
}

extern "C" void exit(){}
#endif 

