
my $APPNAME = $ENV{'PWD'};
$APPNAME =~ s/^.*\///;

$VAR=	{
	'vname' => $APPNAME,
	'name' => "app_$APPNAME",
	'dir'  => "app/$APPNAME",
	'comp' => [
	{
		'vname' => 'Common Files',
		'files' => [
			"$APPNAME.config",
			'run.cmm',
		],
	},
	{
		'srcfile' => 'Makefile.app',
		'file' => 'Makefile',
	},
	{
		vname => "config.xml",
		depends => "&lukas_java",
		'create_symlink' => [ "Keso_$APPNAME/config.xml", 'config.xml' ],
	},
	{
		vname => "config.xml",
		depends => "&lukas_c",
		'generate'=>'generate_config_xml();',
		'file' => 'config.xml',
	},
	{
		vname => "Lukas C variant",
		depends => "&lukas_c",
		files => [
			'appcode.h',
			'common',
			'composition.c',
			'control',
			'device',
			'fsm',
#			'generator',
			'hooks.h',
		],
	},
	],
};
