my $APPNAME = $ENV{'PWD'};
$APPNAME =~ s/^.*\///;

$VAR=	{
	'vname' => $APPNAME,
	'name' => "app_$APPNAME",
	'dir'  => "app/$APPNAME",
	'comp' => [

	# The application source files. You should adopt this to match your actual
	# application
	{
		vname => "application C code",
		files => [
			'*.c',
			'*.cc',
			'*.cpp',
			'*.h',
			'*.hpp',
			'*.ah',
		],
	},

	# common files
	{
		'vname' => 'Common Files',
		'files' => [
			"$APPNAME.config",
		],
	},

	# Makefile for compiling the variant
	{
		'srcfile' => 'Makefile.app',
		'file' => 'Makefile',
	},

	# generates the config.xml from the kconf configuration
	{
		vname => "config.xml",
		'generate'=>'generate_config_xml();',
		'file' => 'config.xml',
	},
	],
};
