#
# MODULE: cplinks
#
# transform symlinks in the $(SRC_DIR) to copies

#find symlinks
SYMLINKS := $(shell find . -type l -printf '%l:%p\n') 

# add all 
MODULES_ALL += cplinks

# 'all' target for 'aspects' MODULE
#
# copies all files 
all_cplinks: 
	@for i in $(SYMLINKS);do \
		export DEST=$${i/*:/}; \
		export SRC=$${i/:*/}; \
		echo "(CPLNK)   $$DEST"; \
	    rm $$DEST; \
		cp -r $$SRC $$DEST&& \
		find $$DEST -type d -name ".svn" | xargs rm -rf; \
	done 
