// $Id: TCBBasic.cpp 995 2009-08-11 14:26:31Z mike $

// dispatcher code must always be inlined
// CXXFLAGS_EXTRA=-finline -finline-functions

#include "TCBBasic.h"

namespace hw { namespace hal {

void TCBBasicBase::kickoff( TCBBasic* me ) {
	me->after_FirstCPUReceive();
	me->start_( me );
	_debug();	// we should never come here
}
void TCBBasic::init( void** tos, ThreadFunc startAddress ) {
	Super::init();
	
	start_ 	= (Super::ThreadFunc) startAddress;
	tos_   	= tos;
}

void TCBBasic::activate_internal( TCBBasic* from, TCBBasic* to ) {

	if( to->hasSeenCPU() )
		from->switchto( to );
	else
		from->start(to);
}




}} 	// namespace hw::hal
