[SECTION .text]

; void Continuation_go(x86Context*)
[GLOBAL Continuation_go]
Continuation_go:
	        mov rbx, [rdi+0x0]
	        mov r12, [rdi+0x8]
	        mov r13, [rdi+0x10]
	        mov r14, [rdi+0x18]
	        mov r15, [rdi+0x20]
	        mov rbp, [rdi+0x28]
	        mov rsp, [rdi+0x30]

			mov rdi, rsi

	        ret

; void toc_switch (x86Context* save_to, x86Context* load_from)
[GLOBAL Continuation_switch]
Continuation_switch:
	        mov [rdi+0x0],  rbx
	        mov [rdi+0x8],  r12
	        mov [rdi+0x10], r13
	        mov [rdi+0x18], r14
	        mov [rdi+0x20], r15
	        mov [rdi+0x28], rbp
	        mov [rdi+0x30], rsp


	        mov rbx, [rsi+0x0]
	        mov r12, [rsi+0x8]
	        mov r13, [rsi+0x10]
	        mov r14, [rsi+0x18]
	        mov r15, [rsi+0x20]
	        mov rbp, [rsi+0x28]
	        mov rsp, [rsi+0x30]

	        mov rdi, rdx

	        ret

