#include "IRQ_E1000.h"

#include "hw/dev/E1000.h"

namespace hw {
namespace irq {

UInt8 IRQ_E1000::REGISTER;

Bool CIAO_INLINE IRQ_E1000::Handler() {
	// advice can bind here
	return true;
}
// The really invoked handler
Bool CIAO_WEAK IRQ_E1000::HWHandler() {
	// TODO: was mache ich damit?
	UInt32 icr = hw::dev::E1000::Inst().getICR();
	hw::dev::E1000::Inst().clearICR();

	return Handler();
}

} // namespace irq
} // namespace hw

