#ifndef __os_irq_Hard_h__
#define __os_irq_Hard_h__

#include "hw/hal/CPU.h"

namespace os { namespace irq {

class Hard {
public:
	void enter () {
		hw::hal::CPU::disable();
	}
	void leave () {
		hw::hal::CPU::enable();
	}
};

}} //os::irq

#endif //__os_irq_Hard_h__

