// $Id: OSControl.h 1205 2010-07-09 15:36:27Z sijesche $
// Created: 2007-06-28 siwahofe

#ifndef __OS_KRN_OS_H__
#define __OS_KRN_OS_H__

#include "as/autosar_types.h"
#include "hw/hal/CPU.h"

namespace os { namespace krn {

class OSControl {
private:
    static OSControl theOSControl_;
	AppModeType currentApplicationMode_;

public:
	static OSControl& Inst () {
		return theOSControl_;
	}

public:
	void startOS (AppModeType appmode);
	void shutdownOS (StatusType error) __attribute__((noreturn));
	AppModeType getApplicationMode ();

private:
	void startScheduling ();
};

}} // namespace os::krn

#endif // __OS_KRN_OS_H__
