#include "constructors.h"

extern "C" {
	extern void (*__CTORS_START)();
	extern void (*__CTORS_END)();

	void run_constructors() {
		// Konstruktoren aller globalen Objektinstanzen aufrufen
		for( void (**ctor)() = &__CTORS_START; ctor != &__CTORS_END; ++ctor )
			(*ctor)();
	}
}
