#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

/*#include "os/krn/Task.h"
#include "os/krn/Alarm.h"
#include "os/krn/AppMode.h"
*/
#include "hw/dev/STM.h"
/*#include "hw/hal/SystemTimer.h"
*/

#include "can_Cfg.h"

#include "hw/dev/can/multican/CanDriverImpl.h"

UInt8 sduBuf[8] = "FIRST!";
hw::dev::can::PduType myPdu0;

void SmallDelay() {
	UInt32 TIMValFirst = hw::dev::STM::TIM<4>();
	while ((hw::dev::STM::TIM<4>() - TIMValFirst) > 10);
}

void Alpha::functionTaskTask0(void) {
	hw::dev::can::multican::CanDriverImpl::Inst().SetControllerMode(0, hw::dev::can::CAN_T_START);
	hw::dev::can::multican::CanDriverImpl::Inst().SetControllerMode(1, hw::dev::can::CAN_T_START);

	myPdu0.Id_          = 22;
	myPdu0.Sdu_         = sduBuf;
	myPdu0.Length_      = 6;
	myPdu0.SwPduHandle_ = 2;

	printf("Calling Write()\r\n");
	hw::dev::can::multican::CanDriverImpl::Inst().Write(0, &myPdu0);
//	SmallDelay();
//	printf("Calling MainFunction_Write()\r\n");
//	hw::dev::can::tc1796multican::CanDriverImpl::Inst().MainFunction_Write();
//	SmallDelay();
//	printf("Calling MainFunction_Read() ... \r\n");
//	hw::dev::can::tc1796multican::CanDriverImpl::Inst().MainFunction_Read();
//	printf("Calling MainFunction_Read() finished\r\n");

	sduBuf[0] = '2';
	printf("Calling Write()\r\n");
	hw::dev::can::multican::CanDriverImpl::Inst().Write(0, &myPdu0);

//	SmallDelay();

	sduBuf[0] = '3';
	printf("Calling Write()\r\n");
	hw::dev::can::multican::CanDriverImpl::Inst().Write(0, &myPdu0);

	AS::TerminateTask();
}
