#ifndef USERCODE1_H_
#define USERCODE1_H_

#include "stdint.h"
#include "os/krn/Messageport.h"
#include "os/net/message.h"
#include "objects.h"

//TODO: SHOULD BE LOCATED IN SOME OS HEADER
#define CIAO_COMPONENT(name) \
class name {\
public:\
	static name &Inst() {\
		return inst_;\
	}\
private:\
	static name inst_;

#define CIAO_COMPONENT_INST(name) name name::inst_;
	
#define TASKDECL(TaskID)\
public:\
	static void functionTask##TaskID (void)

#define TASKDEF(component,TaskID)\
	void component::functionTask##TaskID (void)

#include "messageport_objects.h"

CIAO_COMPONENT(A)
private:
	TASKDECL(T1);
public:
	static void functionISRNetworkISR( void);
};

CIAO_COMPONENT(B)
private:
	TASKDECL(T2);
public:
};

#endif /*USERCODE1_H_*/
